#!/usr/bin/env python
# -*- coding: utf-8 -*-

# It Creates a 700 px leather texture image 

# author: Pocholo
# date: 4/25/22

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugins folder

# Place gimpressionist preset Leather in the gimpressionist preset folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY# without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/lic

from gimpfu import *
import os, sys,time
import gettext
gettext.install("gimp20", gimp.locale_directory, unicode=True)

def pm_page_curl(img, drawable, upper, lower, all):

    #Initiates the temporary state
    pdb.gimp_context_push()
    pdb.gimp_context_set_defaults()
     
    #Start undo
    #pdb.gimp_image_undo_group_start(img)
    
    #Make active the image and save to channel 
    drawable = pdb.gimp_image_get_active_drawable(img)    
    pdb.gimp_image_set_active_layer(img, drawable)
    
    #Convert image to rgb
    indexed = pdb.gimp_drawable_is_indexed(drawable)
    if indexed == True:
        pdb.gimp_image_convert_rgb(img)
        
    #Calculate image size for resizing down
    cur_Width = pdb.gimp_drawable_width(drawable)
    cur_Height = pdb.gimp_drawable_height(drawable)
    newWidth = 2000
    newHeight = cur_Height * newWidth / cur_Width 
    
    #Resize image
    #Images more than 2000 px
    if img.width > 2000:
        pdb.gimp_image_scale(img, newWidth, newHeight)
    
    #Images less than 2000 px
    if img.width < 2000:
       pdb.gimp_image_scale(img, newWidth, newHeight)
    
    #Create the page curl
    if upper==1:
        upperR = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Curl", 100, LAYER_MODE_NORMAL)
        pdb.gimp_image_add_layer(img, upperR, 0)
        pdb.gimp_drawable_fill(upperR, FILL_TRANSPARENT)
        #Use the free select tool
        num_segs = 8
        segs = [2000, 190, 1650, 0, 1600, 190, 2000, 190]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        #Fill the selection
        pdb.gimp_context_set_default_colors()
        pdb.gimp_edit_bucket_fill(upperR,  
                             BUCKET_FILL_FG,  #fill_mode
                          LAYER_MODE_NORMAL,  #paint_mode
                                        100,  #opacity
                                        255,  #threshold
                                      FALSE,  #sample_merged
                                          0,  #x
                                          0)  #y
        pdb.gimp_selection_none(img)
        
        #Use the free select tool
        num_segs = 12
        segs = [0, 0, 1650, 0, 2000, 190, 2000, 5000, 0, 5000, 0, 0]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        pdb.gimp_selection_invert(img)
        pdb.gimp_drawable_edit_clear(drawable)
        pdb.gimp_selection_none(img)
        
        #Apply gradient for the curl effect
        pdb.gimp_image_select_item(img, 2, upperR)
        pdb.gimp_edit_blend(upperR, 
                                    0,  #blend-mode
                    LAYER_MODE_NORMAL,  #paint-mode
                                    1,  #gradient type -  bi-linear
                                  100,  #opacity
                                    0,  #offset
                                    0,  #repeat
                                 TRUE,  #reverse
                                FALSE,  #supersample
                                    3,  #max-depth
                                 0.20,  #threshold
                                 TRUE,  #dither
                                 1630,  #width1
                                  100,  #height1
                                 1660,  #width2
                                    0)  #height2
        
        #Create the curl effect
        pdb.gimp_selection_none(img)
        pdb.gimp_context_set_brush("2. Hardness 100")
        pdb.gimp_context_set_brush_size(220)
        pdb.gimp_context_set_brush_aspect_ratio(0)
        pdb.gimp_context_set_brush_angle(0)
        pdb.gimp_context_set_brush_spacing(0.1)
        pdb.gimp_context_set_dynamics("Dynamics Off")  
        pdb.gimp_eraser_default(upperR, 2, [1600, 96])
        
        #Apply drop shadow
        pdb.script_fu_drop_shadow(img, upperR, -28, -25, 12, ("Black"), 60, FALSE)
        
    if upper==2:
        upperL = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Curl", 100, LAYER_MODE_NORMAL)
        pdb.gimp_image_add_layer(img, upperL, 0)
        pdb.gimp_drawable_fill(upperL, FILL_TRANSPARENT)
        #Use the free select tool
        num_segs = 8
        segs = [2000, 190, 1650, 0, 1600, 190, 2000, 190]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        #Fill the selection
        pdb.gimp_context_set_default_colors()
        pdb.gimp_edit_bucket_fill(upperL,  
                             BUCKET_FILL_FG,  #fill_mode
                          LAYER_MODE_NORMAL,  #paint_mode
                                        100,  #opacity
                                        255,  #threshold
                                      FALSE,  #sample_merged
                                          0,  #x
                                          0)  #y
        pdb.gimp_selection_none(img)
        
        #Use the free select tool
        num_segs = 12
        segs = [0, 0, 1650, 0, 2000, 190, 2000, 5000, 0, 5000, 0, 0]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        pdb.plug_in_sel2path(img, upperL)
        pdb.gimp_selection_none(img)
        vectors = pdb.gimp_image_get_vectors_by_name(img, _("Selection"))
        vectors = pdb.gimp_item_transform_flip_simple(vectors, ORIENTATION_HORIZONTAL, TRUE, 0)
        pdb.gimp_image_select_item(img, 2, vectors)
        pdb.gimp_selection_invert(img)
        pdb.gimp_drawable_edit_clear(drawable)
        pdb.gimp_selection_none(img)
        
        #Apply gradient for the curl effect
        pdb.gimp_image_select_item(img, 2, upperL)
        pdb.gimp_edit_blend(upperL, 
                                 0,  #blend-mode
                 LAYER_MODE_NORMAL,  #paint-mode
                                 1,  #gradient type -  bi-linear
                               100,  #opacity
                                 0,  #offset
                                 0,  #repeat
                              TRUE,  #reverse
                             FALSE,  #supersample
                                 3,  #max-depth
                              0.20,  #threshold
                              TRUE,  #dither
                              1630,  #width1
                               100,  #height1
                              1660,  #width2
                                 0)  #height2
        
        #Create the curl effect
        pdb.gimp_selection_none(img)
        pdb.gimp_context_set_brush("2. Hardness 100")
        pdb.gimp_context_set_brush_size(220)
        pdb.gimp_context_set_brush_aspect_ratio(0)
        pdb.gimp_context_set_brush_angle(0)
        pdb.gimp_context_set_brush_spacing(0.1)
        pdb.gimp_context_set_dynamics("Dynamics Off")  
        pdb.gimp_eraser_default(upperL, 2, [1600, 96])
        upperL = pdb.gimp_item_transform_flip_simple(upperL, ORIENTATION_HORIZONTAL, TRUE, 0)
        
        #Apply drop shadow
        pdb.script_fu_drop_shadow(img, upperL, 28, -20, 12, ("Black"), 60, FALSE)    
        
    if lower==1:
        lowerR = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Curl", 100, LAYER_MODE_NORMAL)
        pdb.gimp_image_add_layer(img, lowerR, 0)
        pdb.gimp_drawable_fill(lowerR, FILL_TRANSPARENT)
        #Use the free select tool
        num_segs = 8
        segs = [2000, 190, 1650, 0, 1600, 190, 2000, 190]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        #Fill the selection
        pdb.gimp_context_set_default_colors()
        pdb.gimp_edit_bucket_fill(lowerR,  
                             BUCKET_FILL_FG,  #fill_mode
                          LAYER_MODE_NORMAL,  #paint_mode
                                        100,  #opacity
                                        255,  #threshold
                                      FALSE,  #sample_merged
                                          0,  #x
                                          0)  #y
        pdb.gimp_selection_none(img)
        
        #Use the free select tool
        num_segs = 12
        segs = [0, 0, 1650, 0, 2000, 190, 2000, 5000, 0, 5000, 0, 0]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        pdb.plug_in_sel2path(img, lowerR)
        pdb.gimp_selection_none(img)
        vectors = pdb.gimp_image_get_vectors_by_name(img, _("Selection"))
        vectors = pdb.gimp_item_transform_flip_simple(vectors, ORIENTATION_VERTICAL, TRUE, 0)
        pdb.gimp_image_select_item(img, 2, vectors)
        pdb.gimp_selection_invert(img)
        pdb.gimp_drawable_edit_clear(drawable)
        pdb.gimp_selection_none(img)
        
        #Apply gradient for the curl effect
        pdb.gimp_image_select_item(img, 2, lowerR)
        pdb.gimp_edit_blend(lowerR, 
                                    0,  #blend-mode
                    LAYER_MODE_NORMAL,  #paint-mode
                                    1,  #gradient type -  bi-linear
                                  100,  #opacity
                                    0,  #offset
                                    0,  #repeat
                                 TRUE,  #reverse
                                FALSE,  #supersample
                                    3,  #max-depth
                                 0.20,  #threshold
                                 TRUE,  #dither
                                 1630,  #width1
                                  100,  #height1
                                 1660,  #width2
                                    0)  #height2
           
        #Create the curl effect
        pdb.gimp_selection_none(img)
        pdb.gimp_context_set_brush("2. Hardness 100")
        pdb.gimp_context_set_brush_size(220)
        pdb.gimp_context_set_brush_aspect_ratio(0)
        pdb.gimp_context_set_brush_angle(0)
        pdb.gimp_context_set_brush_spacing(0.1)
        pdb.gimp_context_set_dynamics("Dynamics Off")  
        pdb.gimp_eraser_default(lowerR, 2, [1600, 96])
        lowerR = pdb.gimp_item_transform_flip_simple(lowerR, ORIENTATION_VERTICAL, TRUE, 0)
        
        #Apply drop shadow
        pdb.script_fu_drop_shadow(img, lowerR, -34, 28, 12, ("Black"), 60, FALSE)
            
    if lower==2:
        lowerL = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Curl", 100, LAYER_MODE_NORMAL)
        pdb.gimp_image_add_layer(img, lowerL, 0)
        pdb.gimp_drawable_fill(lowerL, FILL_TRANSPARENT)
        #Use the free select tool
        num_segs = 8
        segs = [2000, 190, 1650, 0, 1600, 190, 2000, 190]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        #Fill the selection
        pdb.gimp_context_set_default_colors()
        pdb.gimp_edit_bucket_fill(lowerL,  
                             BUCKET_FILL_FG,  #fill_mode
                          LAYER_MODE_NORMAL,  #paint_mode
                                        100,  #opacity
                                        255,  #threshold
                                      FALSE,  #sample_merged
                                          0,  #x
                                          0)  #y
        pdb.gimp_selection_none(img)
        
        #Use the free select tool
        num_segs = 12
        segs = [0, 0, 1650, 0, 2000, 190, 2000, 5000, 0, 5000, 0, 0]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        pdb.plug_in_sel2path(img, lowerL)
        pdb.gimp_selection_none(img)
        vectors = pdb.gimp_image_get_vectors_by_name(img, _("Selection"))
        vectors = pdb.gimp_item_transform_flip_simple(vectors, ORIENTATION_VERTICAL, TRUE, 0)
        vectors = pdb.gimp_item_transform_flip_simple(vectors, ORIENTATION_HORIZONTAL, TRUE, 0)
        pdb.gimp_image_select_item(img, 2, vectors)
        pdb.gimp_selection_invert(img)
        pdb.gimp_drawable_edit_clear(drawable)
        pdb.gimp_selection_none(img)
        
        #Apply gradient for the curl effect
        pdb.gimp_image_select_item(img, 2, lowerL)
        pdb.gimp_edit_blend(lowerL, 
                                    0,  #blend-mode
                    LAYER_MODE_NORMAL,  #paint-mode
                                    1,  #gradient type -  bi-linear
                                  100,  #opacity
                                    0,  #offset
                                    0,  #repeat
                                 TRUE,  #reverse
                                FALSE,  #supersample
                                    3,  #max-depth
                                 0.20,  #threshold
                                 TRUE,  #dither
                                 1630,  #width1
                                  100,  #height1
                                 1660,  #width2
                                    0)  #height2
        
        #Create the curl effect
        pdb.gimp_selection_none(img)
        pdb.gimp_context_set_brush("2. Hardness 100")
        pdb.gimp_context_set_brush_size(220)
        pdb.gimp_context_set_brush_aspect_ratio(0)
        pdb.gimp_context_set_brush_angle(0)
        pdb.gimp_context_set_brush_spacing(0.1)
        pdb.gimp_context_set_dynamics("Dynamics Off")  
        pdb.gimp_eraser_default(lowerL, 2, [1600, 96])
        lowerR = pdb.gimp_item_transform_flip_simple(lowerL, ORIENTATION_VERTICAL, TRUE, 0)
        lowerR = pdb.gimp_item_transform_flip_simple(lowerL, ORIENTATION_HORIZONTAL, TRUE, 0)
        
        #Apply drop shadow
        pdb.script_fu_drop_shadow(img, lowerL, 34, 24, 12, ("Black"), 60, FALSE)    
    
    #Create the page curl
    if all==1:
        upperR = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Curl", 100, LAYER_MODE_NORMAL)
        pdb.gimp_image_add_layer(img, upperR, 0)
        pdb.gimp_drawable_fill(upperR, FILL_TRANSPARENT)
        #Use the free select tool
        num_segs = 8
        segs = [2000, 190, 1650, 0, 1600, 190, 2000, 190]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        #Fill the selection
        pdb.gimp_context_set_default_colors()
        pdb.gimp_edit_bucket_fill(upperR,  
                             BUCKET_FILL_FG,  #fill_mode
                          LAYER_MODE_NORMAL,  #paint_mode
                                        100,  #opacity
                                        255,  #threshold
                                      FALSE,  #sample_merged
                                          0,  #x
                                          0)  #y
        pdb.gimp_selection_none(img)
        
        #Use the free select tool
        num_segs = 12
        segs = [0, 0, 1650, 0, 2000, 190, 2000, 5000, 0, 5000, 0, 0]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        pdb.gimp_selection_invert(img)
        pdb.gimp_drawable_edit_clear(drawable)
        pdb.gimp_selection_none(img)
        
        #Apply gradient for the curl effect
        pdb.gimp_image_select_item(img, 2, upperR)
        pdb.gimp_edit_blend(upperR, 
                                    0,  #blend-mode
                    LAYER_MODE_NORMAL,  #paint-mode
                                    1,  #gradient type -  bi-linear
                                  100,  #opacity
                                    0,  #offset
                                    0,  #repeat
                                 TRUE,  #reverse
                                FALSE,  #supersample
                                    3,  #max-depth
                                 0.20,  #threshold
                                 TRUE,  #dither
                                 1630,  #width1
                                  100,  #height1
                                 1660,  #width2
                                    0)  #height2
        
        #Create the curl effect
        pdb.gimp_selection_none(img)
        pdb.gimp_context_set_brush("2. Hardness 100")
        pdb.gimp_context_set_brush_size(220)
        pdb.gimp_context_set_brush_aspect_ratio(0)
        pdb.gimp_context_set_brush_angle(0)
        pdb.gimp_context_set_brush_spacing(0.1)
        pdb.gimp_context_set_dynamics("Dynamics Off")  
        pdb.gimp_eraser_default(upperR, 2, [1600, 96])
        
        #Apply drop shadow
        pdb.script_fu_drop_shadow(img, upperR, -28, -25, 12, ("Black"), 60, FALSE)
            
        upperL = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Curl", 100, LAYER_MODE_NORMAL)
        pdb.gimp_image_add_layer(img, upperL, 0)
        pdb.gimp_drawable_fill(upperL, FILL_TRANSPARENT)
        #Use the free select tool
        num_segs = 8
        segs = [2000, 190, 1650, 0, 1600, 190, 2000, 190]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        #Fill the selection
        pdb.gimp_context_set_default_colors()
        pdb.gimp_edit_bucket_fill(upperL,  
                             BUCKET_FILL_FG,  #fill_mode
                          LAYER_MODE_NORMAL,  #paint_mode
                                        100,  #opacity
                                        255,  #threshold
                                      FALSE,  #sample_merged
                                          0,  #x
                                          0)  #y
        pdb.gimp_selection_none(img)
        
        #Use the free select tool
        num_segs = 12
        segs = [0, 0, 1650, 0, 2000, 190, 2000, 5000, 0, 5000, 0, 0]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        pdb.plug_in_sel2path(img, upperL)
        pdb.gimp_selection_none(img)
        vectors = pdb.gimp_image_get_vectors_by_name(img, _("Selection"))
        vectors = pdb.gimp_item_transform_flip_simple(vectors, ORIENTATION_HORIZONTAL, TRUE, 0)
        pdb.gimp_image_select_item(img, 2, vectors)
        pdb.gimp_selection_invert(img)
        pdb.gimp_drawable_edit_clear(drawable)
        pdb.gimp_selection_none(img)
        
        #Apply gradient for the curl effect
        pdb.gimp_image_select_item(img, 2, upperL)
        pdb.gimp_edit_blend(upperL, 
                                 0,  #blend-mode
                 LAYER_MODE_NORMAL,  #paint-mode
                                 1,  #gradient type -  bi-linear
                               100,  #opacity
                                 0,  #offset
                                 0,  #repeat
                              TRUE,  #reverse
                             FALSE,  #supersample
                                 3,  #max-depth
                              0.20,  #threshold
                              TRUE,  #dither
                              1630,  #width1
                               100,  #height1
                              1660,  #width2
                                 0)  #height2
        
        #Create the curl effect
        pdb.gimp_selection_none(img)
        pdb.gimp_context_set_brush("2. Hardness 100")
        pdb.gimp_context_set_brush_size(220)
        pdb.gimp_context_set_brush_aspect_ratio(0)
        pdb.gimp_context_set_brush_angle(0)
        pdb.gimp_context_set_brush_spacing(0.1)
        pdb.gimp_context_set_dynamics("Dynamics Off")  
        pdb.gimp_eraser_default(upperL, 2, [1600, 96])
        upperL = pdb.gimp_item_transform_flip_simple(upperL, ORIENTATION_HORIZONTAL, TRUE, 0)
        
        #Apply drop shadow
        pdb.script_fu_drop_shadow(img, upperL, 28, -20, 12, ("Black"), 70, FALSE)    
            
        lowerR = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Curl", 100, LAYER_MODE_NORMAL)
        pdb.gimp_image_add_layer(img, lowerR, 0)
        pdb.gimp_drawable_fill(lowerR, FILL_TRANSPARENT)
        #Use the free select tool
        num_segs = 8
        segs = [2000, 190, 1650, 0, 1600, 190, 2000, 190]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        #Fill the selection
        pdb.gimp_context_set_default_colors()
        pdb.gimp_edit_bucket_fill(lowerR,  
                             BUCKET_FILL_FG,  #fill_mode
                          LAYER_MODE_NORMAL,  #paint_mode
                                        100,  #opacity
                                        255,  #threshold
                                      FALSE,  #sample_merged
                                          0,  #x
                                          0)  #y
        pdb.gimp_selection_none(img)
        
        #Use the free select tool
        num_segs = 12
        segs = [0, 0, 1650, 0, 2000, 190, 2000, 5000, 0, 5000, 0, 0]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        pdb.plug_in_sel2path(img, lowerR)
        pdb.gimp_selection_none(img)
        vectors1 = pdb.gimp_image_get_vectors_by_name(img, _("Selection #1"))
        vectors1 = pdb.gimp_item_transform_flip_simple(vectors1, ORIENTATION_VERTICAL, TRUE, 0)
        pdb.gimp_image_select_item(img, 2, vectors1)
        pdb.gimp_selection_invert(img)
        pdb.gimp_drawable_edit_clear(drawable)
        pdb.gimp_selection_none(img)
        
        #Apply gradient for the curl effect
        pdb.gimp_image_select_item(img, 2, lowerR)
        pdb.gimp_edit_blend(lowerR, 
                                    0,  #blend-mode
                    LAYER_MODE_NORMAL,  #paint-mode
                                    1,  #gradient type -  bi-linear
                                  100,  #opacity
                                    0,  #offset
                                    0,  #repeat
                                 TRUE,  #reverse
                                FALSE,  #supersample
                                    3,  #max-depth
                                 0.20,  #threshold
                                 TRUE,  #dither
                                 1630,  #width1
                                  100,  #height1
                                 1660,  #width2
                                    0)  #height2
           
        #Create the curl effect
        pdb.gimp_selection_none(img)
        pdb.gimp_context_set_brush("2. Hardness 100")
        pdb.gimp_context_set_brush_size(220)
        pdb.gimp_context_set_brush_aspect_ratio(0)
        pdb.gimp_context_set_brush_angle(0)
        pdb.gimp_context_set_brush_spacing(0.1)
        pdb.gimp_context_set_dynamics("Dynamics Off")  
        pdb.gimp_eraser_default(lowerR, 2, [1600, 96])
        lowerR = pdb.gimp_item_transform_flip_simple(lowerR, ORIENTATION_VERTICAL, TRUE, 0)
        
        #Apply drop shadow
        pdb.script_fu_drop_shadow(img, lowerR, -34, 28, 12, ("Black"), 60, FALSE)
        
        lowerL = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Curl", 100, LAYER_MODE_NORMAL)
        pdb.gimp_image_add_layer(img, lowerL, 0)
        pdb.gimp_drawable_fill(lowerL, FILL_TRANSPARENT)
        #Use the free select tool
        num_segs = 8
        segs = [2000, 190, 1650, 0, 1600, 190, 2000, 190]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        #Fill the selection
        pdb.gimp_context_set_default_colors()
        pdb.gimp_edit_bucket_fill(lowerL,  
                             BUCKET_FILL_FG,  #fill_mode
                          LAYER_MODE_NORMAL,  #paint_mode
                                        100,  #opacity
                                        255,  #threshold
                                      FALSE,  #sample_merged
                                          0,  #x
                                          0)  #y
        pdb.gimp_selection_none(img)
        
        #Use the free select tool
        num_segs = 12
        segs = [0, 0, 1650, 0, 2000, 190, 2000, 5000, 0, 5000, 0, 0]
        pdb.gimp_image_select_polygon(img, 2, num_segs, segs)
        pdb.plug_in_sel2path(img, lowerL)
        pdb.gimp_selection_none(img)
        vectors2 = pdb.gimp_image_get_vectors_by_name(img, _("Selection #2"))
        vectors2 = pdb.gimp_item_transform_flip_simple(vectors2, ORIENTATION_VERTICAL, TRUE, 0)
        vectors2 = pdb.gimp_item_transform_flip_simple(vectors2, ORIENTATION_HORIZONTAL, TRUE, 0)
        pdb.gimp_image_select_item(img, 2, vectors2)
        pdb.gimp_selection_invert(img)
        pdb.gimp_drawable_edit_clear(drawable)
        pdb.gimp_selection_none(img)
        
        #Apply gradient for the curl effect
        pdb.gimp_image_select_item(img, 2, lowerL)
        pdb.gimp_edit_blend(lowerL, 
                                    0,  #blend-mode
                    LAYER_MODE_NORMAL,  #paint-mode
                                    1,  #gradient type -  bi-linear
                                  100,  #opacity
                                    0,  #offset
                                    0,  #repeat
                                 TRUE,  #reverse
                                FALSE,  #supersample
                                    3,  #max-depth
                                 0.20,  #threshold
                                 TRUE,  #dither
                                 1630,  #width1
                                  100,  #height1
                                 1660,  #width2
                                    0)  #height2
        
        #Create the curl effect
        pdb.gimp_selection_none(img)
        pdb.gimp_context_set_brush("2. Hardness 100")
        pdb.gimp_context_set_brush_size(220)
        pdb.gimp_context_set_brush_aspect_ratio(0)
        pdb.gimp_context_set_brush_angle(0)
        pdb.gimp_context_set_brush_spacing(0.1)
        pdb.gimp_context_set_dynamics("Dynamics Off")  
        pdb.gimp_eraser_default(lowerL, 2, [1600, 96])
        lowerR = pdb.gimp_item_transform_flip_simple(lowerL, ORIENTATION_VERTICAL, TRUE, 0)
        lowerR = pdb.gimp_item_transform_flip_simple(lowerL, ORIENTATION_HORIZONTAL, TRUE, 0)
        
        #Apply drop shadow
        pdb.script_fu_drop_shadow(img, lowerL, 34, 24, 12, ("Black"), 60, FALSE)    
    
    #Image process
    pdb.gimp_displays_flush()
    
    #End undo
    #pdb.gimp_image_undo_group_end(img)
    
    #Resets the previous user defaults
    pdb.gimp_context_pop()	

register(
    "pm_page_curl",
    "Creates a page curl",
    "Creates a page curl on any image",
    "Pocholo",
    "Pocholo",
    "2022",
    "PM Page Curl",
    "",
    [
    (PF_IMAGE, "img", "Input image", None),
    (PF_LAYER, "drawable", "Input layer", None),
    (PF_OPTION, "upper", "Curl Location", 1, ["None", "Upper right", "Upper left"]),
    (PF_OPTION, "lower", "Curl Location", 0, ["None", "Lower right", "Lower left"]),
    (PF_OPTION, "all", "All sides", 0, ["None", "All corners"]),
    ], 
    [],
    pm_page_curl, menu="<Image>/Filters/Distorts/",
    domain=("gimp20", gimp.locale_directory))
main()	